Subject: Re: [PATCH] deploy: Support --target and --system.

From: Roman Scherer <[email-masked]>
Date: Mon, 17 Mar 2025 18:31:03 +0100

So, I tried building this machine on an aarch64 system with the qemu-bin
service running now a couple of times ...

```
(use-modules (gnu machine)
             (gnu machine hetzner))

(list (machine
       (operating-system %hetzner-os-x86)
       (environment hetzner-environment-type)
       (configuration (hetzner-configuration
                       (server-type "cx42")
                       (ssh-key "/home/roman/workspace/guix/id_rsa")))))
```

I used this command:

```
[roman@m1 guix]$ ./pre-inst-env guix deploy hetzner-minimal.scm --no-offload --target=x86_64-linux-gnu --timeout=864000 --max-silent-time=864000
The following 1 machine will be deployed:
  guix-x86

guix deploy: deploying to guix-x86...
guix deploy: warning: <machine-ssh-configuration> without a 'host-key' is deprecated
substitute: looking for substitutes on 'https://substitutes.asahi-guix.org'... 100.0%
substitute: looking for substitutes on 'https://substitutes.nonguix.org'... 100.0%
substitute: looking for substitutes on 'https://bordeaux.guix.gnu.org'... 100.0%
substitute: looking for substitutes on 'https://ci.guix.gnu.org'... 100.0%
The following derivations will be built:
  /gnu/store/0ma7qrdd5pz8421rka75mvmvhkvn1rld-libxcrypt-4.4.36.drv
  /gnu/store/8js0zmi3c2zg7ks3qnpiwsckam37vi67-guile-3.0.9.drv

building /gnu/store/0ma7qrdd5pz8421rka75mvmvhkvn1rld-libxcrypt-4.4.36.drv...
```

And it always "hangs" there. I haven't much investigated this yet. Just
a small update.

Roman

Roman Scherer <[email-masked]> writes:

> Hello Sergey,
>
> this looks good to me and is better than what we have now. I'm testing
> this right now and will report back when it went through ...
>
> But I'm wondering if the target architecture should ideally be choosen
> per machine. Say you have 2 machines with different architectures in a
> list of machines you want to deploy.
>
> I don't see a "system" field in the machine or operating system
> record. So I'm not sure if we have a way to infer that yet.
>
> Would it make sense to add such a field and chose the target
> architecture per machine?
>
> Thanks, Roman.